<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPhoneTypeDisplayInstanceRes StructType
 * @subpackage Structs
 */
class GetPhoneTypeDisplayInstanceRes extends APIResponse
{
    /**
     * The displayInstance
     * Meta informations extracted from the WSDL
     * - maxLength: 32
     * @var string
     */
    public $displayInstance;
    /**
     * Constructor method for GetPhoneTypeDisplayInstanceRes
     * @uses GetPhoneTypeDisplayInstanceRes::setDisplayInstance()
     * @param string $displayInstance
     */
    public function __construct($displayInstance = null)
    {
        $this
            ->setDisplayInstance($displayInstance);
    }
    /**
     * Get displayInstance value
     * @return string|null
     */
    public function getDisplayInstance()
    {
        return $this->displayInstance;
    }
    /**
     * Set displayInstance value
     * @param string $displayInstance
     * @return GetPhoneTypeDisplayInstanceRes
     */
    public function setDisplayInstance($displayInstance = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($displayInstance) && strlen($displayInstance) > 32) || (is_array($displayInstance) && count($displayInstance) > 32)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 32 element(s) or a scalar of 32 character(s) at most, "%d" length given', is_scalar($displayInstance) ? strlen($displayInstance) : count($displayInstance)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($displayInstance) && !is_string($displayInstance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($displayInstance)), __LINE__);
        }
        $this->displayInstance = $displayInstance;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return GetPhoneTypeDisplayInstanceRes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
